/*
    * DESCRIPTION
 * The ESP32 gateway sends data received from sensors to the WiFi link.
 * The gateway also accepts input on ethernet interface, which is then sent out to the radio network.
 * ----------- PINOUT --------------
 * | IO   | RF24 | RFM69 | RFM95 |
  |------|------|-------|-------|
  | MOSI | 23   | 23    | 23    |
  | MISO | 19   | 19    | 19    |
  | SCK  | 18   | 18    | 18    |
  | CSN  | 5    | 5     | 5     |
  | CE   | 17   | -     | -     |
  | RST  | -    | 17    | 17    |
  | IRQ  | 16*  | 16    | 16    |
*/


// Enable debug prints to serial monitor
#define MY_DEBUG

// Enables and select radio type (if attached)
#define MY_RADIO_RF24

//#define MY_RF24_PA_LEVEL RF24_PA_MAX

//#define RF24_DATARATE    RF24_250KBPS

#define MY_RF24_CE_PIN 4

#define MY_RF24_CS_PIN 5

#define MY_GATEWAY_ESP32


#define MY_WIFI_SSID "****"
#define MY_WIFI_PASSWORD "*****"

// Set the hostname for the WiFi Client. This is the hostname
// it will pass to the DHCP server if not static.
//#define MY_HOSTNAME "ESP32_GW"

// Enable MY_IP_ADDRESS here if you want a static ip address (no DHCP)
//#define MY_IP_ADDRESS 192, 168, 2, 121

#define MY_IP_ADDRESS 192, 168, 2, 123



// If using static ip you can define Gateway and Subnet address as well
#define MY_IP_GATEWAY_ADDRESS 192, 168, 2, 100
#define MY_IP_SUBNET_ADDRESS 255, 255, 255, 0

// The port to keep open on node server mode
#define MY_PORT 5003

// How many clients should be able to connect to this gateway (default 1)
#define MY_GATEWAY_MAX_CLIENTS 2

// Advanced Gateway Options
#define MY_DEFAULT_LED_BLINK_PERIOD 50

// Flash leds on rx/tx/err
// Led pins used if blinking feature is enabled above
//#define MY_DEFAULT_ERR_LED_PIN 32  // Transfer data error led pin
//#define MY_DEFAULT_RX_LED_PIN  25  // Receive Data led pin
//#define MY_DEFAULT_TX_LED_PIN  27  // Transmit Data led pin

#define MY_DEFAULT_ERR_LED_PIN 26  // Transfer data error led pin
#define MY_DEFAULT_RX_LED_PIN  22  // Receive Data led pin
#define MY_DEFAULT_TX_LED_PIN  21  // Transmit Data led pin

#define CHILD_ID 1

float noda24temp = 0;
float noda24bat = 0;

float noda112vout = 0;
float noda112iout = 0;
float noda112pout = 0;
float noda112batt = 0;

float noda60temp = 0;
float noda60hum = 0;
float noda60pres = 0;
float noda60batt = 0;

float noda133temp = 0;
float noda133hum = 0;
float noda133batt = 0;

float noda134temp = 0;
float noda134hum = 0;

float noda135temp = 0;
float noda135hum = 0;

float noda136temp = 0;
float noda136hum = 0;

#define STATE_OFF     0
#define STATE_ON      1
#define STATE_UNKNOWN 2

byte noo2state = STATE_OFF;

bool releSt1 = 0;

bool releSt = 3; // вот на это может ругаться, что переменная не объявлена
String spisok = ""; // 
// modules
#define FEATURE_UPLOAD
#define FEATURE_TIME
#define FEATURE_NTP
#define FEATURE_SEND
#define FEATURE_MAJOR
#define FEATURE_KEYS
//#define FEATURE_BME
#define HTTP_FEATURE


// debug

#define SERIAL_PRINT

#include <pgmspace.h>

#include "FS.h"
#include "SPIFFS.h"

#include <WiFi.h>
#include <TimeLib.h>


#include <ArduinoOTA.h>
#include <MySensors.h>


MyMessage msg(CHILD_ID, V_TEXT);

#define SELF_NAME F("ESP32_MSG")
//byte SELF_IP[] = {192, 168, 2, 121};
byte SELF_IP[] = {192, 168, 2, 123};

// Authorization
#define AUTH_OFF 0
#define AUTH_ON  1
byte authMode = AUTH_OFF;
// online encode: base64encode.org
String AUTH_HASH = "Authorization: Basic YWRtaW46YW1z"; // admin:ams

// time provider
#define TIME_NONE     0
#define TIME_NETWORK  1
#define TIME_RTC      2
//byte timeProvider = TIME_NETWORK;

byte timeProvider = TIME_NONE;

// mode work
#define MODE_SERVER   1
#define MODE_UPDATE   2
byte modeWork = MODE_SERVER;

// duration
time_t prevEventElectroCycle;
time_t prevEventEspLive;
time_t prevEventRequest;


// время апдейта

  unsigned long lpTempOldUpdate  = 0;
  unsigned long lpTempUpdate  = 0;

  unsigned long lpContOldUpdate  = 0;
  unsigned long lpContUpdate  = 0; 

  unsigned long lpTemp1OldUpdate  = 0;
  unsigned long lpTemp1Update  = 0; 

  unsigned long lpTemp2OldUpdate  = 0;
  unsigned long lpTemp2Update  = 0;     
//

// modules
#define DISABLE       0
#define ENABLE        1
#define NOT_COMPILLED 2
byte moduleUpload   = NOT_COMPILLED;
byte moduleTime     = NOT_COMPILLED;
byte moduleNtp      = NOT_COMPILLED;
byte moduleEthernet = NOT_COMPILLED;
byte moduleSd       = NOT_COMPILLED;
byte moduleServer   = NOT_COMPILLED;
byte moduleSend     = NOT_COMPILLED;
byte moduleMajor    = NOT_COMPILLED;
byte modulePing     = NOT_COMPILLED;
byte modulePirs     = NOT_COMPILLED;
byte moduleContacts = NOT_COMPILLED;
byte moduleTemp     = NOT_COMPILLED;
byte moduleLeds     = NOT_COMPILLED; 
byte moduleKeys     = NOT_COMPILLED;
byte moduleElectro  = NOT_COMPILLED;
byte moduleNoo      = NOT_COMPILLED;
byte moduleMr1132   = NOT_COMPILLED;
byte moduleNrf24    = NOT_COMPILLED;

byte moduleRobotdyn = NOT_COMPILLED;

byte moduleDHT      = NOT_COMPILLED;

byte moduleTlog     = NOT_COMPILLED;

byte moduleTwundergr = NOT_COMPILLED;

byte moduleBME       = NOT_COMPILLED;

byte moduleHTTP      = NOT_COMPILLED;//=====================



// timers
boolean cycle1s  = false;
boolean cycle5s  = false;
boolean cycle10s = false;
boolean cycle20s = false;
boolean cycle30s = false;
boolean cycle1m  = false;
boolean cycle3m  = false;
boolean cycle5m  = false;
boolean cycle15m = false; // добавил таймера
boolean cycle30m = false;
boolean cycle1h  = false;
boolean cycle1d  = false;
boolean cycle7d  = false;
boolean cycle30d = false; // добавил таймера

// strings
char buf[200];

// cyclos
unsigned long cyclos = 0;

#ifdef FEATURE_LEDS
  #define LED_EMPTY 0
  #define LED_PIR 1
  byte modeLed = LED_EMPTY;
#endif

void install() {

}

void receive(const MyMessage &message)
{
  if (message.type ==  V_STATUS) {
//    state = message.getBool();
 }

  // получаем сразу все данные из строки ДЕБАГА и разбираем её )))

  Serial.println("message");
  Serial.print("sensor: ");
  Serial.println(message.sensor);
  Serial.print("type: ");
  Serial.println(message.type);
  Serial.print("getBool(): ");
  Serial.println(message.getBool());
  Serial.print("getByte(): ");
  Serial.println(message.getByte());
  Serial.print("getString(): ");
  Serial.println(message.getString());

  
 // Serial.println(message.getCustomString());
 // Serial.println(message.getStream());
 // Serial.println(message.getCustom());
  Serial.println(message.getFloat());
  Serial.println(message.getInt());
  Serial.println(message.getLong());
  Serial.print("getCommand(): ");
  Serial.println(message.getCommand());
  Serial.print("getSensor(): ");
  Serial.println(message.getSensor());
  Serial.print("getSender(): ");
  Serial.println(message.getSender());
  Serial.print("getDestination(): ");
  Serial.println(message.getDestination());
  Serial.print("getHeaderSize(): ");
  Serial.println(message.getHeaderSize());
  Serial.print("getPayloadType(): ");
  Serial.println(message.getPayloadType());
  Serial.print("getLength(): ");
  Serial.println(message.getLength());
  Serial.print("getExpectedMessageSize(): ");
  Serial.println(message.getExpectedMessageSize());
  Serial.print("isProtocolVersionValid(): ");
  Serial.println(message.isProtocolVersionValid());
  Serial.print("getLast(): ");
  Serial.println(message.getLast());
  Serial.print("isEcho(): ");
  Serial.println(message.isEcho());
  Serial.print("getRequestEcho(): ");
  Serial.println(message.getRequestEcho());
  Serial.print("getVersion(): ");
  Serial.println(message.getVersion());
  Serial.print("getSigned(): ");
  Serial.println(message.getSigned());
//
//
 // getSensor(): 1
//  getSender(): 0
//  getDestination(): 133


    if ((message.getSensor() == 0) && (message.getSender() == 24)) {
    noda24temp = message.getFloat();
//===============================
   lpContUpdate = (millis() - lpContOldUpdate) / 1000;
         Serial.print(F("Update: ")); Serial.println(lpContUpdate);
   lpContOldUpdate = millis();
 //================================  
  }

    if ((message.getSensor() == 1) && (message.getSender() == 24)) {
    noda24bat = message.getFloat();
    }

      if ((message.getSensor() == 0) && (message.getSender() == 112)) {
    noda112vout = message.getFloat();
//===============================
  //lpTemp3Update = (millis() - lpTemp3OldUpdate) / 1000;
        // Serial.print(F("Update: ")); Serial.println(lpTemp3Update);
  // lpTemp3OldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 1) && (message.getSender() == 112)) {
    noda112iout = message.getFloat();
  }

        if ((message.getSensor() == 2) && (message.getSender() == 112)) {
    noda112pout = message.getFloat();
  }

          if ((message.getSensor() == 3) && (message.getSender() == 112)) {
    noda112batt = message.getFloat();
  }    

    if ((message.getSensor() == 1) && (message.getSender() == 133)) {
    noda133temp = message.getFloat();
//===============================
   lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
         Serial.print(F("Update: ")); Serial.println(lpTempUpdate);
   lpTempOldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 2) && (message.getSender() == 133)) {
    noda133hum = message.getFloat();
  }

      if ((message.getSensor() == 110) && (message.getSender() == 133)) {
    noda133batt = message.getFloat();
  } 

      if ((message.getSensor() == 1) && (message.getSender() == 134)) {
    noda134temp = message.getFloat();
//===============================
  // lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
    //     Serial.print(F("Update: ")); Serial.println(lpTempUpdate);
  // lpTempOldUpdate = millis();
 //================================  
  }



      if ((message.getSensor() == 2) && (message.getSender() == 134)) {
    noda134hum = message.getFloat();
  }

        if ((message.getSensor() == 1) && (message.getSender() == 135)) {
    noda135temp = message.getFloat();
//===============================
  // lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
    //     Serial.print(F("Update: ")); Serial.println(lpTempUpdate);
  // lpTempOldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 2) && (message.getSender() == 135)) {
    noda135hum = message.getFloat();
  }

          if ((message.getSensor() == 1) && (message.getSender() == 136)) {
    noda136temp = message.getFloat();
//===============================
  // lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
    //     Serial.print(F("Update: ")); Serial.println(lpTempUpdate);
  // lpTempOldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 2) && (message.getSender() == 136)) {
    noda136hum = message.getFloat();
  }

      if ((message.getSensor() == 0) && (message.getSender() == 60)) {
    noda60temp = message.getFloat();
//===============================
  lpTemp1Update = (millis() - lpTemp1OldUpdate) / 1000;
         Serial.print(F("Update: ")); Serial.println(lpTemp1Update);
   lpTemp1OldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 1) && (message.getSender() == 60)) {
    noda60hum = message.getFloat();
  }

        if ((message.getSensor() == 2) && (message.getSender() == 60)) {
    noda60pres = message.getFloat();
  }

          if ((message.getSensor() == 3) && (message.getSender() == 60)) {
    noda60batt = message.getFloat();
  }
  if ((message.getCommand() == 1) && (message.getSender() == 30)) {
    if (message.getSensor() == 1) { // данные с сенсора 1 ноды 30 к прмеру может быть температура (вы сами определяете номер сенсора для температуры)
      releSt = message.getBool();

    }
  }
// отправляем на ноду подтверждение, что получили данные и шлем её ответ ))) сразу )))

//  if ((message.getCommand() == 1) && (message.getSender() == 0) && (message.getSensor() == 1) && (message.getDestination() == 22)) {
//    //Confirmation_Answer_Accepted = 1;
//    //sleep_CHANGE = 0;
//    Serial.println(message.getString()); 
//    Serial.println("data for Sensor 22"); 
//    String str = message.getString();
//    str.trim();
//    Serial.println(message.getString()); 
//    if (str == "HIGH") {
//      //s = send(msg.setDestination(0).set("LOW")); 
//      send(msg.setDestination(22).set("Close")); 
//      Serial.println(message.getString()); 
//    }
//    if (str == "LOW") {
//      send(msg.setDestination(22).set("Open")); 
//      Serial.println(message.getString()); 
//    }
//  }  
}

void setup() {

    // Setup locally attached sensors
  ArduinoOTA.onStart([]() {
    Serial.println("Start updating");
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd updating");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("OTA Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) {
      Serial.println("Auth Failed");
    } else if (error == OTA_BEGIN_ERROR) {
      Serial.println("Begin Failed");
    } else if (error == OTA_CONNECT_ERROR) {
      Serial.println("Connect Failed");
    } else if (error == OTA_RECEIVE_ERROR) {
      Serial.println("Receive Failed");
    } else if (error == OTA_END_ERROR) {
      Serial.println("End Failed");
    }
  });
  ArduinoOTA.begin();
  //===============================================================

  initSerial();
  printWelcome();
  initSpiffs();
  initRandom();
  install();
  initEeprom();
  initAbstract();
  initHardware();
  initTimers();
  initWifi();
  initNtp();
  initTime();
  
  initServer();

  #ifdef FEATURE_UPLOAD
    initUpload();
  #endif
  #ifdef FEATURE_SEND
    initSend();
  #endif
  #ifdef FEATURE_MAJOR
    initMajordomo();

    majordomoEspLive();
  #endif
  #ifdef FEATURE_TEMP
    initTemp();
  #endif
  #ifdef FEATURE_CONTACTS
    initContacts();
  #endif
  #ifdef FEATURE_PIRS
    initPirs();
  #endif
  #ifdef FEATURE_LEDS
    initLeds();
  #endif
  #ifdef FEATURE_KEYS
    initKeys();
  #endif

  #ifdef ROBOTDYN_FEATURE
    initRobotdyn();
  #endif

  #ifdef FEATURE_DHT
    initDHT();
  #endif

  //==================
  #ifdef FEATURE_MYSEN
    initMYSEN();
  #endif
  //=====================

    #ifdef FEATURE_BME
    Initbme();
  #endif


  #ifdef FEATURE_NRF24
    InitNrf24();
  #endif
  
  #ifdef FEATURE_ELECTRO
    initElectro();
  #endif
  

 #ifdef FEATURE_TLOG
    initTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
    initTwundergr();
  #endif

  #ifdef HTTP_FEATURE
    initHttp();
  #endif
 
  printInitDone();

  //testInit();

} // setup

void loop() {
  // Send locally attached sensors data here

  ArduinoOTA.handle();
  
  #ifdef FEATURE_UPLOAD
    workUpload();
  #endif

  if (modeWork == MODE_SERVER) {
    workTimers();
    workTime();
    workServer();
  
    #ifdef FEATURE_TEMP
      workTemp();
    #endif
    #ifdef FEATURE_CONTACTS
      workContacts();
    #endif
    #ifdef FEATURE_PIRS
      workPirs();
    #endif
    #ifdef FEATURE_KEYS
      workKeys();
    #endif

    #ifdef FEATURE_DHT
      workDHT();
    #endif


    #ifdef FEATURE_MAJOR
      majordomoEspLive();
    #endif



    
     #ifdef FEATURE_ELECTRO

       if (moduleElectro == 1) {
        if (cycle20s) {
          workElectro();
          freqWorks();
        }
        // network oscilloscope
        if (cycle1s && oscill) {
          freqWorks();
        }
      }
    #endif

        #ifdef FEATURE_BME

    if (cycle20s) {
      bmeWorks();
    }
    #endif

 

  #ifdef ROBOTDYN_FEATURE
    workRobotdyn();
  #endif

   #ifdef FEATURE_TLOG
    workTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
   workTwundergr();
  #endif

    #ifdef HTTP_FEATURE
     httpWork();
    #endif

        if (cycle5s) {
        lpTempUpdate = (millis() - lpTempOldUpdate) / 60000;
        lpContUpdate = (millis() - lpContOldUpdate) / 60000;
        lpTemp1Update =(millis() - lpTemp1OldUpdate)/ 60000;
        lpTemp2Update =(millis() - lpTemp2OldUpdate)/ 60000;

   }

    workAbstract();
    workLoopEnd();
  
  } // MODE_SERVER

  reconnectWiFi();
} // loop

