/*
  Module Wi-Fi
  part of Arduino Mega Server project
*/

char ssid[] = "******";
char pass[] = "*******";

IPAddress ip = SELF_IP;
IPAddress gateway(192, 168, 2, 100);
IPAddress subnet(255, 255, 255, 0);

unsigned long wifi_time = 0;
unsigned long wifi_interval = 30000; // 30 sec.

void WiFiEvent(WiFiEvent_t event){ // ++++++++++++++++
  switch (event) {
    case SYSTEM_EVENT_STA_START:
      WiFi.config(ip, gateway, subnet);
    break;
    case SYSTEM_EVENT_STA_CONNECTED:
      Serial.println(F(" WiFi: connected"));
    break;
    case SYSTEM_EVENT_STA_GOT_IP:
      Serial.print(F(" IP address: "));
      Serial.println(WiFi.localIP());
    break;
  }
}

void initWifi() {
  initStart(F( "Wi-Fi"), false);
  Serial.print(F(" Connecting to: ")); Serial.println(ssid);
  WiFi.onEvent(WiFiEvent); // +++++++++++++++++
  WiFi.mode(WIFI_STA);
  //delay(10); // -------------------
  WiFi.begin(ssid, pass);
  //WiFi.config(ip, gateway, subnet); // -----------------------
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(F("."));
  }
  Serial.println();
  //Serial.println(F(" WiFi: connected"));
  //Serial.print(F(" IP address: "));
  //Serial.println(WiFi.localIP());

            Serial.println(" (");
            Serial.print(WiFi.RSSI());
            Serial.print(")");
            
  initDone(false);
}

 void workWifi() {
  
    if(cycle1m) { 
            timeStamp();
           // Serial.print(i + 1);
            Serial.print("WiFi : ");
            Serial.print(WiFi.SSID());
            Serial.print(" (");
            Serial.print(WiFi.RSSI());
            Serial.print(")");
     }
     
 }

void reconnectWiFi(){
  unsigned long g_time = millis();
  if(g_time - wifi_time > wifi_interval){
    if (WiFi.status() != WL_CONNECTED){
      Serial.println(F(" reconnect to WiFi"));
      WiFi.disconnect(true, true);
      WiFi.mode(WIFI_OFF);
      WiFi.onEvent(WiFiEvent);
      WiFi.mode(WIFI_STA);
      WiFi.begin(ssid, pass);
    }
    wifi_time = millis();
  }
}

